ompi/op/op.h File Reference.TH "ompi/op/op.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/op/op.h \- Public interface for the MPI_Op handle. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'mpi.h'\fP
.br
\fC#include 'datatype/datatype.h'\fP
.br
\fC#include 'opal/class/opal_object.h'\fP
.br
\fC#include 'class/ompi_pointer_array.h'\fP
.br
\fC#include 'mpi/f77/fint_2_int.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBOMPI_OP_FLAGS_INTRINSIC\fP   0x0001"
.br
.RI "\fISet if the MPI_Op is a built-in operation. \fP"
.ti -1c
.RI "#define \fBOMPI_OP_FLAGS_FORTRAN_FUNC\fP   0x0002"
.br
.RI "\fISet if the callback function is in Fortran. \fP"
.ti -1c
.RI "#define \fBOMPI_OP_FLAGS_ASSOC\fP   0x0004"
.br
.RI "\fISet if the callback function is associative (MAX and SUM will both have ASSOC set -- in fact, it will only *not* be set if we implement some extensions to MPI, because MPI says that all MPI_Op's should be associative, so this flag is really here for future expansion). \fP"
.ti -1c
.RI "#define \fBOMPI_OP_FLAGS_FLOAT_ASSOC\fP   0x0008"
.br
.RI "\fISet if the callback function is associative for floating point operands (e.g., MPI_SUM will have ASSOC set, but will *not* have FLOAT_ASSOC set). \fP"
.ti -1c
.RI "#define \fBOMPI_OP_FLAGS_COMMUTE\fP   0x0010"
.br
.RI "\fISet if the callback function is communative. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef void() \fBompi_op_c_handler_fn_t\fP (void *, void *, int *, MPI_Datatype *)"
.br
.RI "\fITypedef for C op functions. \fP"
.ti -1c
.RI "typedef void() \fBompi_op_fortran_handler_fn_t\fP (void *, void *, MPI_Fint *, MPI_Fint *)"
.br
.RI "\fITypedef for fortran op functions. \fP"
.ti -1c
.RI "typedef \fBompi_op_t\fP \fBompi_op_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum { \fBOMPI_OP_FORTRAN_NULL\fP =  0, \fBOMPI_OP_FORTRAN_MAX\fP, \fBOMPI_OP_FORTRAN_MIN\fP, \fBOMPI_OP_FORTRAN_SUM\fP, \fBOMPI_OP_FORTRAN_PROD\fP, \fBOMPI_OP_FORTRAN_LAND\fP, \fBOMPI_OP_FORTRAN_BAND\fP, \fBOMPI_OP_FORTRAN_LOR\fP, \fBOMPI_OP_FORTRAN_BOR\fP, \fBOMPI_OP_FORTRAN_LXOR\fP, \fBOMPI_OP_FORTRAN_BXOR\fP, \fBOMPI_OP_FORTRAN_MAXLOC\fP, \fBOMPI_OP_FORTRAN_MINLOC\fP, \fBOMPI_OP_FORTRAN_REPLACE\fP, \fBOMPI_OP_FORTRAN_MAX_TYPE\fP }"
.br
.RI "\fIFortran handles; must be [manually set to be] equivalent to the values in \fBmpif.h\fP. \fP"
.ti -1c
.RI "enum { \fBOMPI_OP_TYPE_INT\fP, \fBOMPI_OP_TYPE_LONG\fP, \fBOMPI_OP_TYPE_SHORT\fP, \fBOMPI_OP_TYPE_UNSIGNED_SHORT\fP, \fBOMPI_OP_TYPE_UNSIGNED\fP, \fBOMPI_OP_TYPE_UNSIGNED_LONG\fP, \fBOMPI_OP_TYPE_LONG_LONG\fP, \fBOMPI_OP_TYPE_LONG_LONG_INT\fP, \fBOMPI_OP_TYPE_UNSIGNED_LONG_LONG\fP, \fBOMPI_OP_TYPE_INTEGER\fP, \fBOMPI_OP_TYPE_INTEGER1\fP, \fBOMPI_OP_TYPE_INTEGER2\fP, \fBOMPI_OP_TYPE_INTEGER4\fP, \fBOMPI_OP_TYPE_INTEGER8\fP, \fBOMPI_OP_TYPE_INTEGER16\fP, \fBOMPI_OP_TYPE_FLOAT\fP, \fBOMPI_OP_TYPE_DOUBLE\fP, \fBOMPI_OP_TYPE_REAL\fP, \fBOMPI_OP_TYPE_REAL4\fP, \fBOMPI_OP_TYPE_REAL8\fP, \fBOMPI_OP_TYPE_REAL16\fP, \fBOMPI_OP_TYPE_DOUBLE_PRECISION\fP, \fBOMPI_OP_TYPE_LONG_DOUBLE\fP, \fBOMPI_OP_TYPE_LOGICAL\fP, \fBOMPI_OP_TYPE_COMPLEX\fP, \fBOMPI_OP_TYPE_DOUBLE_COMPLEX\fP, \fBOMPI_OP_TYPE_COMPLEX8\fP, \fBOMPI_OP_TYPE_COMPLEX16\fP, \fBOMPI_OP_TYPE_COMPLEX32\fP, \fBOMPI_OP_TYPE_BYTE\fP, \fBOMPI_OP_TYPE_2REAL\fP, \fBOMPI_OP_TYPE_2DOUBLE_PRECISION\fP, \fBOMPI_OP_TYPE_2INTEGER\fP, \fBOMPI_OP_TYPE_FLOAT_INT\fP, \fBOMPI_OP_TYPE_DOUBLE_INT\fP, \fBOMPI_OP_TYPE_LONG_INT\fP, \fBOMPI_OP_TYPE_2INT\fP, \fBOMPI_OP_TYPE_SHORT_INT\fP, \fBOMPI_OP_TYPE_LONG_DOUBLE_INT\fP, \fBOMPI_OP_TYPE_WCHAR\fP, \fBOMPI_OP_TYPE_MAX\fP }"
.br
.RI "\fICorresponding to the types that we can reduce over. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBompi_op_init\fP (void)"
.br
.RI "\fIInitialize the op interface. \fP"
.ti -1c
.RI "int \fBompi_op_finalize\fP (void)"
.br
.RI "\fIFinalize the op interface. \fP"
.ti -1c
.RI "\fBompi_op_t\fP * \fBompi_op_create\fP (bool commute, \fBompi_op_fortran_handler_fn_t\fP *func)"
.br
.RI "\fICreate a \fBompi_op_t\fP. \fP"
.ti -1c
.RI "static bool \fBompi_op_is_intrinsic\fP (\fBompi_op_t\fP *op)"
.br
.RI "\fICheck to see if an op is intrinsic. \fP"
.ti -1c
.RI "static bool \fBompi_op_is_commute\fP (\fBompi_op_t\fP *op)"
.br
.RI "\fICheck to see if an op is communative or not. \fP"
.ti -1c
.RI "static bool \fBompi_op_is_float_assoc\fP (\fBompi_op_t\fP *op)"
.br
.RI "\fICheck to see if an op is floating point associative or not. \fP"
.ti -1c
.RI "static bool \fBompi_op_is_valid\fP (\fBompi_op_t\fP *op, ompi_datatype_t *ddt, char **msg, const char *func)"
.br
.RI "\fICheck to see if an op is valid on a given datatype. \fP"
.ti -1c
.RI "static void \fBompi_op_reduce\fP (\fBompi_op_t\fP *op, void *source, void *target, int count, ompi_datatype_t *dtype)"
.br
.RI "\fIPerform a reduction operation. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_op_ddt_map\fP [DT_MAX_PREDEFINED]"
.br
.RI "\fIArray to map ddt->id values to the corresponding position in the op function array. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_op_t\fP \fBompi_mpi_op_null\fP"
.br
.RI "\fIGlobal variable for MPI_OP_NULL. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_op_t\fP \fBompi_mpi_op_max\fP"
.br
.RI "\fIGlobal variable for MPI_MAX. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_op_t\fP \fBompi_mpi_op_min\fP"
.br
.RI "\fIGlobal variable for MPI_MIN. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_op_t\fP \fBompi_mpi_op_sum\fP"
.br
.RI "\fIGlobal variable for MPI_SUM. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_op_t\fP \fBompi_mpi_op_prod\fP"
.br
.RI "\fIGlobal variable for MPI_PROD. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_op_t\fP \fBompi_mpi_op_land\fP"
.br
.RI "\fIGlobal variable for MPI_LAND. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_op_t\fP \fBompi_mpi_op_band\fP"
.br
.RI "\fIGlobal variable for MPI_BAND. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_op_t\fP \fBompi_mpi_op_lor\fP"
.br
.RI "\fIGlobal variable for MPI_LOR. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_op_t\fP \fBompi_mpi_op_bor\fP"
.br
.RI "\fIGlobal variable for MPI_BOR. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_op_t\fP \fBompi_mpi_op_lxor\fP"
.br
.RI "\fIGlobal variable for MPI_LXOR. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_op_t\fP \fBompi_mpi_op_bxor\fP"
.br
.RI "\fIGlobal variable for MPI_BXOR. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_op_t\fP \fBompi_mpi_op_maxloc\fP"
.br
.RI "\fIGlobal variable for MPI_MAXLOC. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_op_t\fP \fBompi_mpi_op_minloc\fP"
.br
.RI "\fIGlobal variable for MPI_MINLOC. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_op_t\fP \fBompi_mpi_op_replace\fP"
.br
.RI "\fIGlobal variable for MPI_REPLACE. \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBompi_pointer_array_t\fP * \fBompi_op_f_to_c_table\fP"
.br
.RI "\fITable for Fortran <-> C op handle conversion. \fP"
.in -1c
.SH "Detailed Description"
.PP 
Public interface for the MPI_Op handle. 


.SH "Typedef Documentation"
.PP 
.SS "typedef void() \fBompi_op_c_handler_fn_t\fP(void *, void *, int *, MPI_Datatype *)"
.PP
Typedef for C op functions. 
.PP
We don't use MPI_User_function because this would create a confusing dependency loop between this file and \fBmpi.h\fP. So this is repeated code, but it's better this way (and this typedef will never change, so there's not much of a maintenance worry). 
.SH "Enumeration Type Documentation"
.PP 
.SS "anonymous enum"
.PP
Fortran handles; must be [manually set to be] equivalent to the values in \fBmpif.h\fP. 
.PP
\fBEnumeration values: \fP
.in +1c
.TP
\fB\fIOMPI_OP_FORTRAN_NULL \fP\fP
Corresponds to Fortran MPI_OP_NULL. 
.TP
\fB\fIOMPI_OP_FORTRAN_MAX \fP\fP
Corresponds to Fortran MPI_MAX. 
.TP
\fB\fIOMPI_OP_FORTRAN_MIN \fP\fP
Corresponds to Fortran MPI_MIN. 
.TP
\fB\fIOMPI_OP_FORTRAN_SUM \fP\fP
Corresponds to Fortran MPI_SUM. 
.TP
\fB\fIOMPI_OP_FORTRAN_PROD \fP\fP
Corresponds to Fortran MPI_PROD. 
.TP
\fB\fIOMPI_OP_FORTRAN_LAND \fP\fP
Corresponds to Fortran MPI_LAND. 
.TP
\fB\fIOMPI_OP_FORTRAN_BAND \fP\fP
Corresponds to Fortran MPI_BAND. 
.TP
\fB\fIOMPI_OP_FORTRAN_LOR \fP\fP
Corresponds to Fortran MPI_LOR. 
.TP
\fB\fIOMPI_OP_FORTRAN_BOR \fP\fP
Corresponds to Fortran MPI_BOR. 
.TP
\fB\fIOMPI_OP_FORTRAN_LXOR \fP\fP
Corresponds to Fortran MPI_LXOR. 
.TP
\fB\fIOMPI_OP_FORTRAN_BXOR \fP\fP
Corresponds to Fortran MPI_BXOR. 
.TP
\fB\fIOMPI_OP_FORTRAN_MAXLOC \fP\fP
Corresponds to Fortran MPI_MAXLOC. 
.TP
\fB\fIOMPI_OP_FORTRAN_MINLOC \fP\fP
Corresponds to Fortran MPI_MINLOC. 
.TP
\fB\fIOMPI_OP_FORTRAN_REPLACE \fP\fP
Corresponds to Fortran MPI_REPLACE. 
.TP
\fB\fIOMPI_OP_FORTRAN_MAX_TYPE \fP\fP
Maximum value. 
.SS "anonymous enum"
.PP
Corresponding to the types that we can reduce over. 
.PP
See MPI-1:4.9.2, p114-115. 
.PP
\fBEnumeration values: \fP
.in +1c
.TP
\fB\fIOMPI_OP_TYPE_INT \fP\fP
C integer: int. 
.TP
\fB\fIOMPI_OP_TYPE_LONG \fP\fP
C integer: long. 
.TP
\fB\fIOMPI_OP_TYPE_SHORT \fP\fP
C integer: short. 
.TP
\fB\fIOMPI_OP_TYPE_UNSIGNED_SHORT \fP\fP
C integer: unsigned short. 
.TP
\fB\fIOMPI_OP_TYPE_UNSIGNED \fP\fP
C integer: unsigned. 
.TP
\fB\fIOMPI_OP_TYPE_UNSIGNED_LONG \fP\fP
C integer: unsigned long. 
.TP
\fB\fIOMPI_OP_TYPE_LONG_LONG \fP\fP
C integer: long long (optional). 
.TP
\fB\fIOMPI_OP_TYPE_LONG_LONG_INT \fP\fP
C integer: long long int (optional). 
.TP
\fB\fIOMPI_OP_TYPE_UNSIGNED_LONG_LONG \fP\fP
C integer: unsigned long long (optional). 
.TP
\fB\fIOMPI_OP_TYPE_INTEGER \fP\fP
Fortran integer. 
.TP
\fB\fIOMPI_OP_TYPE_INTEGER1 \fP\fP
Fortran integer*1. 
.TP
\fB\fIOMPI_OP_TYPE_INTEGER2 \fP\fP
Fortran integer*2. 
.TP
\fB\fIOMPI_OP_TYPE_INTEGER4 \fP\fP
Fortran integer*4. 
.TP
\fB\fIOMPI_OP_TYPE_INTEGER8 \fP\fP
Fortran integer*8. 
.TP
\fB\fIOMPI_OP_TYPE_INTEGER16 \fP\fP
Fortran integer*16. 
.TP
\fB\fIOMPI_OP_TYPE_FLOAT \fP\fP
Floating point: float. 
.TP
\fB\fIOMPI_OP_TYPE_DOUBLE \fP\fP
Floating point: double. 
.TP
\fB\fIOMPI_OP_TYPE_REAL \fP\fP
Floating point: real. 
.TP
\fB\fIOMPI_OP_TYPE_REAL4 \fP\fP
Floating point: real*4. 
.TP
\fB\fIOMPI_OP_TYPE_REAL8 \fP\fP
Floating point: real*8. 
.TP
\fB\fIOMPI_OP_TYPE_REAL16 \fP\fP
Floating point: real*16. 
.TP
\fB\fIOMPI_OP_TYPE_DOUBLE_PRECISION \fP\fP
Floating point: double precision. 
.TP
\fB\fIOMPI_OP_TYPE_LONG_DOUBLE \fP\fP
Floating point: long double. 
.TP
\fB\fIOMPI_OP_TYPE_LOGICAL \fP\fP
Logical. 
.TP
\fB\fIOMPI_OP_TYPE_COMPLEX \fP\fP
Complex. 
.TP
\fB\fIOMPI_OP_TYPE_DOUBLE_COMPLEX \fP\fP
Double complex. 
.TP
\fB\fIOMPI_OP_TYPE_COMPLEX8 \fP\fP
Complex8. 
.TP
\fB\fIOMPI_OP_TYPE_COMPLEX16 \fP\fP
Complex16. 
.TP
\fB\fIOMPI_OP_TYPE_COMPLEX32 \fP\fP
Complex32. 
.TP
\fB\fIOMPI_OP_TYPE_BYTE \fP\fP
Byte. 
.TP
\fB\fIOMPI_OP_TYPE_2REAL \fP\fP
2 location Fortran: 2 real 
.TP
\fB\fIOMPI_OP_TYPE_2DOUBLE_PRECISION \fP\fP
2 location Fortran: 2 double precision 
.TP
\fB\fIOMPI_OP_TYPE_2INTEGER \fP\fP
2 location Fortran: 2 integer 
.TP
\fB\fIOMPI_OP_TYPE_FLOAT_INT \fP\fP
2 location C: float int 
.TP
\fB\fIOMPI_OP_TYPE_DOUBLE_INT \fP\fP
2 location C: double int 
.TP
\fB\fIOMPI_OP_TYPE_LONG_INT \fP\fP
2 location C: long int 
.TP
\fB\fIOMPI_OP_TYPE_2INT \fP\fP
2 location C: int int 
.TP
\fB\fIOMPI_OP_TYPE_SHORT_INT \fP\fP
2 location C: short int 
.TP
\fB\fIOMPI_OP_TYPE_LONG_DOUBLE_INT \fP\fP
2 location C: long double int 
.TP
\fB\fIOMPI_OP_TYPE_WCHAR \fP\fP
2 location C: wchar_t 
.TP
\fB\fIOMPI_OP_TYPE_MAX \fP\fP
Maximum type. 
.SH "Function Documentation"
.PP 
.SS "\fBompi_op_t\fP* ompi_op_create (bool commute, \fBompi_op_fortran_handler_fn_t\fP * func)"
.PP
Create a \fBompi_op_t\fP. 
.PP
\fBParameters:\fP
.RS 4
\fIcommute\fP Boolean indicating whether the operation is communative or not 
.br
\fIfunc\fP Function pointer of the error handler
.RE
.PP
\fBReturns:\fP
.RS 4
op Pointer to the \fBompi_op_t\fP that will be created and returned
.RE
.PP
This function is called as the back-end of all the MPI_OP_CREATE functions. It creates a new \fBompi_op_t\fP object, initializes it to the correct object type, and sets the callback function on it.
.PP
The type of the function pointer is (arbitrarily) the fortran function handler type. Since this function has to accept 2 different function pointer types (lest we have 2 different functions to create errhandlers), the fortran one was picked arbitrarily. Note that (void*) is not sufficient because at least theoretically, a sizeof(void*) may not necessarily be the same as sizeof(void(*)).
.PP
NOTE: It *always* sets the 'fortran' flag to false. The Fortran wrapper for MPI_OP_CREATE is expected to reset this flag to true manually. 
.SS "int ompi_op_finalize (void)"
.PP
Finalize the op interface. 
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS Always
.RE
.PP
Invokes from \fBompi_mpi_finalize()\fP; tears down the op interface, and destroys the F2C translation table. 
.SS "int ompi_op_init (void)"
.PP
Initialize the op interface. 
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS Upon success 
.PP
OMPI_ERROR Otherwise
.RE
.PP
Invoked from \fBompi_mpi_init()\fP; sets up the op interface, creates the predefined MPI operations, and creates the corresopnding F2C translation table. 
.SS "static bool ompi_op_is_commute (\fBompi_op_t\fP * op)\fC [inline, static]\fP"
.PP
Check to see if an op is communative or not. 
.PP
\fBParameters:\fP
.RS 4
\fIop\fP The op to check
.RE
.PP
\fBReturns:\fP
.RS 4
true If the op is communative 
.PP
false If the op is not communative
.RE
.PP
Self-explanitory. This is needed in a few top-level MPI functions; this function is provided to hide the internal structure field names. 
.SS "static bool ompi_op_is_float_assoc (\fBompi_op_t\fP * op)\fC [inline, static]\fP"
.PP
Check to see if an op is floating point associative or not. 
.PP
\fBParameters:\fP
.RS 4
\fIop\fP The op to check
.RE
.PP
\fBReturns:\fP
.RS 4
true If the op is floating point associative 
.PP
false If the op is not floating point associative
.RE
.PP
Self-explanitory. This is needed in a few top-level MPI functions; this function is provided to hide the internal structure field names. 
.SS "static bool ompi_op_is_intrinsic (\fBompi_op_t\fP * op)\fC [inline, static]\fP"
.PP
Check to see if an op is intrinsic. 
.PP
\fBParameters:\fP
.RS 4
\fIop\fP The op to check
.RE
.PP
\fBReturns:\fP
.RS 4
true If the op is intrinsic 
.PP
false If the op is not intrinsic
.RE
.PP
Self-explanitory. This is needed in a few top-level MPI functions; this function is provided to hide the internal structure field names. 
.SS "static bool ompi_op_is_valid (\fBompi_op_t\fP * op, ompi_datatype_t * ddt, char ** msg, const char * func)\fC [inline, static]\fP"
.PP
Check to see if an op is valid on a given datatype. 
.PP
\fBParameters:\fP
.RS 4
\fIop\fP The op to check 
.br
\fIddt\fP The datatype to check
.RE
.PP
\fBReturns:\fP
.RS 4
true If the op is valid on that datatype 
.PP
false If the op is not valid on that datatype
.RE
.PP
Self-explanitory. This is needed in a few top-level MPI functions; this function is provided to hide the internal structure field names. 
.SS "static void ompi_op_reduce (\fBompi_op_t\fP * op, void * source, void * target, int count, ompi_datatype_t * dtype)\fC [inline, static]\fP"
.PP
Perform a reduction operation. 
.PP
\fBParameters:\fP
.RS 4
\fIop\fP The operation (IN) 
.br
\fIsource\fP Source (input) buffer (IN) 
.br
\fItarget\fP Target (output) buffer (IN/OUT) 
.br
\fIcount\fP Number of elements (IN) 
.br
\fIdtype\fP MPI datatype (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
void As with MPI user-defined reduction functions, there is no return code from this function.
.RE
.PP
Perform a reduction operation with count elements of type dtype in the buffers source and target. The target buffer obtains the result (i.e., the original values in the target buffer are reduced with the values in the source buffer and the result is stored in the target buffer).
.PP
This function figures out which reduction operation function to invoke and whether to invoke it with C- or Fortran-style invocation methods. If the op is intrinsic and has the operation defined for dtype, the appropriate back-end function will be invoked. Otherwise, the op is assumed to be a user op and the first function pointer in the op array will be used.
.PP
NOTE: This function assumes that a correct combination will be given to it; it makes no provision for errors (in the name of optimization). If you give it an intrinsic op with a datatype that is not defined to have that operation, it is likely to seg fault. 
.SH "Variable Documentation"
.PP 
.SS "OMPI_DECLSPEC int \fBompi_op_ddt_map\fP[DT_MAX_PREDEFINED]"
.PP
Array to map ddt->id values to the corresponding position in the op function array. 
.PP
NOTE: It is possible to have an implementation without this map. There are basically 3 choices for implementing 'how to find the right position in the op array based on the datatype':
.PP
1. Use the exact same ordering as ddt->id in the op map. This is nice in that it's always a direct lookup via one memory de-reference. But it makes a sparse op array, and it's at least somewhat wasteful. It also chains the ddt and op implementations together. If the ddt ever changes its ordering, op is screwed. It seemed safer from a maintenance point of view not to do it that way.
.PP
2. Re-arrange the ddt ID values so that all the reducable types are at the beginning. This means that we can have a dense array here in op, but then we have the same problem as number one -- and so this didn't seem like a good idea from a maintenance point of view.
.PP
3. Create a mapping between the ddt->id values and the position in the op array. This allows a nice dense op array, and if we make the map based on symbolic values, then if ddt ever changes its ordering, it won't matter to op. This seemed like the safest thing to do from a maintenance perspective, and since it only costs one extra lookup, and that lookup is way cheaper than the function call to invoke the reduction operation, it seemed like the best idea. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
